# -*- coding: utf-8 -*-
"""Arquitectura.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1nqJj1baUhL6-dmOU9hCAlRIClV5Panm2
"""

# try:
#   import transformers       #libreria transformers     
#   from transformers import BertModel, BertConfig, BertPreTrainedModel
# except ModuleNotFoundError:
#   !pip install transformers
#   import transformers                                   
#   from transformers import BertModel, BertConfig, BertPreTrainedModel

import transformers                                   
from transformers import BertConfig, BertModel, BertPreTrainedModel, BertTokenizer
import torch
import torch.nn as nn
from torch.nn import CrossEntropyLoss


def model_factory(cuda = True):
    config = BertConfig.from_pretrained('bert-base-multilingual-cased', num_labels = 13)
    class BertForSequenceClassification(BertPreTrainedModel):
        def __init__(self, config, weight=None):
            super(BertForSequenceClassification, self).__init__(config)
            self.num_labels = config.num_labels
            self.bert = BertModel(config)
            self.dropout = nn.Dropout(config.hidden_dropout_prob)
            self.classifier = nn.Linear(config.hidden_size, self.config.num_labels)
            self.weight = weight
            self.init_weights()
        def forward(
            self,
            input_ids=None,
            attention_mask=None,
            token_type_ids=None,
            position_ids=None,
            head_mask=None,
            inputs_embeds=None,
            labels=None,
            Phase=None,
        ):
            outputs = self.bert(
                input_ids,
                attention_mask=attention_mask,
                token_type_ids=token_type_ids,
                position_ids=position_ids,
                head_mask=head_mask,
            )
            pooled_output = outputs[1]    
            pooled_output = self.dropout(pooled_output)
            logits = self.classifier(pooled_output)
            outputs = (logits,) + outputs[2:]

            if (Phase == 'train' or Phase == 'test'):
                loss_fct = CrossEntropyLoss(weight=self.weight)
                loss = loss_fct(logits.view(-1, self.num_labels), labels.view(-1))
                outputs= (loss,) + outputs

            return outputs 
        
    model = BertForSequenceClassification(config)
    if cuda:
        model.to('cuda')
    else:
        model.to('cpu')

    return model


def weights_load(PATH, cuda = True):
    tokenizer = BertTokenizer.from_pretrained('bert-base-multilingual-cased')
    model = model_factory(cuda = cuda)
    if cuda:
        model.load_state_dict(torch.load(PATH, map_location = torch.device('cuda')))
    else:
        model.load_state_dict(torch.load(PATH, map_location = torch.device('cpu')))
    model.eval()
    return model, tokenizer


def model_inference(text, tokenizer, model):
    encoding = tokenizer(text, return_tensors='pt', padding=True, truncation=True).to('cpu')
    text_ids = encoding['input_ids']
    prediction = model(text_ids)
    label = torch.argmax(prediction[0]).item() 
    return label


def data_cleansing(text,tool):
    text=tool.correct(text)
    text = str(text).lower()
    return text

def db_value(etiqueta,database):
    if etiqueta == 0:
        rtemp="1.- "
        respuesta =database.child("contenido").get()
        for it,i in enumerate(respuesta.val()):
            if it>0 and it<=10:
                rtemp = rtemp + i + "\n\n" + str(it+1) + ".- "
        respuesta=rtemp
        return respuesta
    else:
        respuesta = database.child("contenido/"+str(etiqueta)).get()
        respuesta = respuesta.val()
        return respuesta